#include <cstdio>
#include <cmath>

struct point
{
	double x, y;
	point(){};
	point(double _x, double _y): x(_x), y(_y){};
};

inline point operator- (const point &a, const point &b)
{
	return point(a.x - b.x, a.y - b.y);
}

inline double cp(const point &a, const point &b)
{
	return a.x * b.y - a.y * b.x;
}

inline double cp(const point &a, const point &b, const point &c)
{
	return cp(b - a, c - a);
}

inline double dist(const point &a, const point &b)
{
	return sqrt( (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) );
}

int L;
int N;
point p[105][2];
double d[105];
int main()
{
	scanf("%d", &L);
	scanf("%d", &N);
	for(int i = 0; i < N; i ++)	scanf("%lf %lf %lf %lf", &p[i][0].x, &p[i][0].y, &p[i][1].x, &p[i][1].y);
	for(int i = 0; i < N; i ++)	d[i] = dist(p[i][0], p[i][1]);
	for(int x = 0; x <= L; x ++)
		for(int y = 0; y <= L; y ++)
		{
			bool ok = 1;
			for(int i = 0; i < N; i ++)
				if( 50. * d[i] >= fabs(cp(p[i][0], p[i][1], point(x, y))) )
				{
					ok = 0;
					break;
				}
			if( ok )
			{
				printf("%d %d\n", x, y);
				return 0;
			}
		}
    return 0;
}
