#include <cstdio>
#include <ctime>
#include <cmath>
#include <cstdlib>

const int MAXN = 1 << 7;
const double eps = 1e-14;

struct point {
	double x , y;
	
	point () {}
	point ( double _x , double _y ) : x(_x) , y(_y) {}
};

double l;
int n;
point a[MAXN][2];

void read() {
	int i;
	
	scanf ("%lf%d",&l,&n);
	for (i=1;i<=n;i++)
		scanf ("%lf%lf%lf%lf",&a[i][0].x,&a[i][0].y,&a[i][1].x,&a[i][1].y);
}

inline double dot ( point a , point b , point c ) {
	return (b.x - a.x) * (c.x - b.x) + (b.y - a.y) * (c.y - b.y);
}

inline double cross ( point a , point b , point c ) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

inline double d ( point a , point b ) {
	return sqrt ( (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) );
}

inline double dist ( point a , point b , point c ) {
	if ( dot ( a , b , c ) > eps ) return d ( b , c );
	if ( dot ( b , a , c ) > eps ) return d ( a , c );
	return cross ( a , b , c ) / d ( a , b );
}

int check ( double x , double y ) {
	int i;
	
	for (i=1;i<=n;i++)
		if ( dist ( a[i][0] , a[i][1] , point ( x , y ) ) < 50 + eps ) return 0;
	
	return 1;
}

void solve() {
	double x , y;
	
	x = 0.; y = 0.;
	if ( check ( x , y ) ) {
		printf ("%lf %lf\n",x,y);
		return ;
	}
	
	x = 0.; y = l;
	if ( check ( x , y ) ) {
		printf ("%lf %lf\n",x,y);
		return ;
	}
	
	x = l; y = 0.;
	if ( check ( x , y ) ) {
		printf ("%lf %lf\n",x,y);
		return ;
	}
	
	x = l; y = l;
	if ( check ( x , y ) ) {
		printf ("%lf %lf\n",x,y);
		return ;
	}
	
	while ( (double)clock() / CLOCKS_PER_SEC < 0.9 ) {
		x = fmod ( (double)rand() / 100000000. + (double)rand() , l );
		y = fmod ( (double)rand() / 100000000. + (double)rand() , l );

		if ( check ( x , y ) ) {
			printf ("%lf %lf\n",x,y);
			return ;
		}
	}
	
	printf ("NO WAY\n");
}

int main() {
	read();
	solve();
	
	return 0;
}
