#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>

#define ldouble double

struct pointi {
	int x, y;
	
	pointi() { }
	pointi(int _x, int _y) : x(_x), y(_y) { }
	pointi(pointi& a, pointi& b) {
		x = b.x - a.x;
		y = b.y - a.y;
	}
};
struct pointd {
	ldouble x, y;
	
	pointd() { }
	pointd(ldouble _x, ldouble _y) : x(_x), y(_y) { }
	pointd(pointd& a, pointd& b) {
		x = b.x - a.x;
		y = b.y - a.y;
	}
	pointd(pointi a) {
		x = a.x;
		y = a.y;
	}
	
	pointd operator+ (pointd a) {
		return pointd(a.x+x, a.y+y);
	}
};
ldouble tarea(pointd a, pointd b) {
	return a.x*b.y - a.y*b.x;
}
ldouble atan2(pointd a, pointd b) {
	return atan2(b.x - a.x, b.y - a.y);
}
ldouble abs(ldouble a) {
	return a < 0 ? -a : a;
}
ldouble min(ldouble a, ldouble b) {
	return a < b ? a : b;
}

int N;
#define MAXN 32
int d[MAXN];

int S;
#define MAXS 32
pointd r[MAXS];

pointd p[MAXN];

struct protein {
	ldouble value;
	ldouble a[MAXN];
	
	protein() {
		for(int i = 0; i < N; ++i) a[i] = 0;
	}
	
	/*protein(protein& p) {
		for(int i = 0; i < N; ++i) a[i] = p.a[i];
	}*/
	
	void evaluate() {
		//printf("evaluating\n");
		//printf("angles: ");
		//for(int i = 0; i < N; ++i) printf("%lf ", a[i]);
		//printf("\npoints:\n0 0\n");
		
		for(int i = 1; i <= N; ++i) {
			p[i] = p[i-1] + pointd(d[i-1] * cos(a[i-1]), d[i-1] * sin(a[i-1]));
			//printf("%lf %lf\n", p[i].x, p[i].y);
		}
		
		//printf("Evaluating raycasts\n");
		value = 0;
		for(int ir = 0; ir < S; ++ir) {
			//printf("Evaluating %lf %lf\n", r[ir].x, r[ir].y);
			int lm = 0, rm = 0;
			for(int ip = 1; ip <= N; ++ip) {
				if(tarea(pointd(r[ir], p[lm]), pointd(r[ir], p[ip])) < 0)
					lm = ip;
				if(tarea(pointd(r[ir], p[rm]), pointd(r[ir], p[ip])) > 0)
					rm = ip;
			}
			//printf("LM: %lf %lf\nRM: %lf %lf\n", p[lm].x, p[lm].y, p[rm].x, p[rm].y);
			//printf("LMA: %lf\n", atan2(r[ir], p[lm]));
			//printf("RMA: %lf\n", atan2(r[ir], p[rm]));
			//printf("A: %lf\n", atan2(r[ir], p[lm]) - atan2(r[ir], p[rm]));
			value += min(	abs(atan2(r[ir], p[lm]) - atan2(r[ir], p[rm])),
							abs(atan2(r[ir], p[rm]) + atan2(r[ir], p[lm])));
		}
	}
	
	void print() {
		/*printf("evaluating\n");
		printf("angles: ");
		for(int i = 0; i < N; ++i) printf("%lf ", a[i]);
		printf("\npoints:\n0 0\n");
		
		for(int i = 1; i <= N; ++i) {
			p[i] = p[i-1] + pointd(d[i-1] * cos(a[i-1]), d[i-1] * sin(a[i-1]));
			printf("%lf %lf\n", p[i].x, p[i].y);
		}
		
		printf("Evaluating raycasts\n");
		ldouble nvalue = 0, cvalue;
		for(int ir = 0; ir < S; ++ir) {
			printf("Evaluating %lf %lf\n", r[ir].x, r[ir].y);
			int lm = 0, rm = 0;
			for(int ip = 1; ip <= N; ++ip) {
				if(tarea(pointd(r[ir], p[lm]), pointd(r[ir], p[ip])) < 0)
					lm = ip;
				if(tarea(pointd(r[ir], p[rm]), pointd(r[ir], p[ip])) > 0)
					rm = ip;
			}
			printf("LM: %lf %lf\nRM: %lf %lf\n", p[lm].x, p[lm].y, p[rm].x, p[rm].y);
			printf("LMA: %lf\n", atan2(r[ir], p[lm]));
			printf("RMA: %lf\n", atan2(r[ir], p[rm]));
			cvalue = min(	abs(atan2(r[ir], p[lm]) - atan2(r[ir], p[rm])),
							abs(atan2(r[ir], p[rm]) + atan2(r[ir], p[lm])));
			printf("A: %lf\n", cvalue);
			nvalue += cvalue;
		}
		printf("Value: %lf\n", nvalue);*/
		
		for(int i = 1; i <= N; ++i) {
			p[i] = p[i-1] + pointd(d[i-1] * cos(a[i-1]), d[i-1] * sin(a[i-1]));
			printf("%lf %lf\n", p[i].x, p[i].y);
		}
		//printf("%lf\n", value);
	}
	
	void randomize(double coef) {
		//printf("%lf ", coef);
		//printf("old: ");
		for(int i = 0; i < N; ++i) {
			//printf("%lf ", a[i]);
			a[i] += (rand()-RAND_MAX/2) / (double)RAND_MAX * 2 * coef;
			
			if(a[i] > M_PI*2) a[i] -= M_PI*2;
			if(a[i] < -M_PI*2) a[i] += M_PI*2;
		}
		//printf("\nnew: ");
		//for(int i = 0; i < N; ++i) printf("%lf ", a[i]);
		//printf("\n");
	}
};

void input() {
	scanf("%d%d", &N, &S);
	for(int i = 0; i < N; ++i) scanf("%d", d+i);
	for(int i = 0; i < S; ++i) scanf("%lf%lf", &r[i].x, &r[i].y);
}

int pcmp(const void *a, const void *b) {
	double dif = ((protein*)b)->value - ((protein*)a)->value;
	if(dif < 0) return -1;
	if(dif > 0) return 1;
	return 0;
}

#define LIVE 46
#define BREED 46

protein gen[LIVE];
protein ngen[LIVE*BREED];

long tstart;

protein genetics() {
	protein start;
	for(int i = 0; i < LIVE; ++i) {
		gen[i] = start;
		gen[i].randomize(sqrt( (double)i / LIVE ));
		gen[i].evaluate();
	}
	
	int generations = 1;
	while(1) {
		for(int j = 0; j < LIVE; ++j) {
			for(int k = 0; k < BREED; ++k) {
				ngen[j*k] = gen[j];
				ngen[j*k].randomize( sqrt( (double)k / BREED / 3 ) );
				ngen[j*k].evaluate();
			}
		}
		qsort(ngen, LIVE*BREED, sizeof(protein), pcmp);
		for(int i = 0; i < LIVE; ++i) {
			gen[i] = ngen[i];
		}
		
		if(clock()-tstart >= CLK_TCK * 4.7)
			break;
		
		++generations;
	}
	//printf("%d\n", generations);
	return gen[0];
}

int main() {
	tstart = clock();
	
	srand(time(0));
	input();
	
	/*pointd p1 = pointd(0.063234, 0.997999);
	pointd p2 = pointd(0.969643, 2.780812);
	pointd p3 = pointd(-2.818488, 4.065359);
	pointd p4 = pointd(-5.365588, 5.650377);
	pointd p5 = pointd(-6.065061, 6.365036);
	
	protein p;
	
	p.a[0] = atan2(pointd(0, 0), p1);
	p.a[1] = atan2(p1, p2);
	p.a[2] = atan2(p2, p3);
	p.a[3] = atan2(p3, p4);
	p.a[4] = atan2(p4, p5);
	
	p.evaluate();
	p.print();*/
	protein p = genetics();
	p.print();
	return 0;
}
